"use strict";

Liferay.Loader.define("change-tracking-change-lists-history-web@1.0.13/js/ChangeListsHistory.es", ['module', 'exports', 'require', 'frontend-taglib-clay$clay-label', 'frontend-taglib-clay$clay-progress-bar', 'frontend-taglib-clay$clay-sticker', 'frontend-js-web/liferay/PortletBase.es', 'frontend-js-web/liferay/toast/commands/OpenToast.es', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './ChangeListsHistory.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = exports.ChangeListsHistory = void 0;

  require("frontend-taglib-clay$clay-label");

  require("frontend-taglib-clay$clay-progress-bar");

  require("frontend-taglib-clay$clay-sticker");

  var _PortletBase2 = _interopRequireDefault(require("frontend-js-web/liferay/PortletBase.es"));

  var _OpenToast = require("frontend-js-web/liferay/toast/commands/OpenToast.es");

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _ChangeListsHistory = _interopRequireDefault(require("./ChangeListsHistory.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }

  function _typeof(obj) {
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var TIMEOUT_FIRST = 3000;
  var TIMEOUT_INTERVAL = 60000;
  var USER_FILTER_ALL = -1;
  /**
   * Handles the tags of the selected file entries inside a modal.
   */

  var ChangeListsHistory =
  /*#__PURE__*/
  function (_PortletBase) {
    _inherits(ChangeListsHistory, _PortletBase);

    function ChangeListsHistory() {
      _classCallCheck(this, ChangeListsHistory);

      return _possibleConstructorReturn(this, _getPrototypeOf(ChangeListsHistory).apply(this, arguments));
    }

    _createClass(ChangeListsHistory, [{
      key: "created",
      value: function created() {
        var headers = new Headers();
        headers.append('Content-Type', 'application/json');
        headers.append('X-CSRF-Token', Liferay.authToken);
        var init = {
          credentials: 'include',
          headers: headers,
          method: 'GET'
        };

        var urlProcesses = this._getUrlProcesses();

        this._fetchProcesses(urlProcesses, init);

        var instance = this;
        setTimeout(function () {
          return instance._fetchProcesses(urlProcesses, init);
        }, TIMEOUT_FIRST, urlProcesses, init);
        setInterval(function () {
          return instance._fetchProcesses(urlProcesses, init);
        }, TIMEOUT_INTERVAL, urlProcesses, init);
      }
    }, {
      key: "_fetchProcesses",
      value: function _fetchProcesses(urlProcesses, init) {
        var _this = this;

        fetch(urlProcesses, init).then(function (r) {
          return r.json();
        }).then(function (response) {
          return _this._populateProcessEntries(response);
        }).catch(function (error) {
          var message = typeof error === 'string' ? error : Liferay.Util.sub(Liferay.Language.get('an-error-occured-while-getting-data-from-x'), _this.urlProcesses);
          (0, _OpenToast.openToast)({
            message: message,
            title: Liferay.Language.get('error'),
            type: 'danger'
          });
        });
        var urlProcessUsers = this.urlProcessUsers + '&type=' + this.filterStatus + '&offset=0&limit=5';

        if (this.keywords) {
          urlProcessUsers = urlProcessUsers + '&keywords=' + this.keywords;
        }

        fetch(urlProcessUsers, init).then(function (r) {
          return r.json();
        }).then(function (response) {
          return _this._populateProcessUsers(response);
        }).catch(function (error) {
          var message = typeof error === 'string' ? error : Liferay.Util.sub(Liferay.Language.get('an-error-occured-while-getting-data-from-x'), _this.urlProcessUsers);
          (0, _OpenToast.openToast)({
            message: message,
            title: Liferay.Language.get('error'),
            type: 'danger'
          });
        });
      }
    }, {
      key: "_getUrlProcesses",
      value: function _getUrlProcesses() {
        var sort = '&sort=' + this.orderByCol + ':' + this.orderByType;
        var urlProcesses = this.urlProcesses + '&type=' + this.filterStatus + '&offset=0&limit=5' + sort;

        if (this.filterUser > 0) {
          urlProcesses = urlProcesses + '&user=' + this.filterUser;
        } else {
          urlProcesses += '&user=' + USER_FILTER_ALL;
        }

        if (this.keywords) {
          urlProcesses = urlProcesses + '&keywords=' + this.keywords;
        }

        return urlProcesses;
      }
    }, {
      key: "_populateProcessUsers",
      value: function _populateProcessUsers(processUsers) {
        var _this2 = this;

        AUI().use('liferay-portlet-url', function (A) {
          var managementToolbar = Liferay.component('changeListHistoryManagementToolbar');
          var filterByUserIndex = managementToolbar.filterItems.findIndex(function (e) {
            return e.label === 'Filter by User';
          });
          var filterByUserItems = managementToolbar.filterItems[filterByUserIndex].items;
          var updatedFilterByUserItems = [];
          updatedFilterByUserItems.push(filterByUserItems[filterByUserItems.findIndex(function (e) {
            return e.label === 'All';
          })]);
          processUsers.forEach(function (processUser) {
            var userFilterUrl = Liferay.PortletURL.createURL(_this2.baseURL);
            userFilterUrl.setParameter('displayStyle', 'list');
            userFilterUrl.setParameter('orderByCol', _this2.orderByCol);
            userFilterUrl.setParameter('orderByType', _this2.orderByType);
            userFilterUrl.setParameter('user', processUser.userId);
            updatedFilterByUserItems.push({
              'active': _this2.filterUser === processUser.userId.toString(),
              'href': userFilterUrl.toString(),
              'label': processUser.userName,
              'type': 'item'
            });
          });
          managementToolbar.filterItems[filterByUserIndex].items = updatedFilterByUserItems;
        });
      }
    }, {
      key: "_populateProcessEntries",
      value: function _populateProcessEntries(processEntries) {
        var _this3 = this;

        AUI().use('liferay-portlet-url', function (A) {
          _this3.processEntries = [];
          processEntries.forEach(function (processEntry) {
            var detailsLink = Liferay.PortletURL.createURL(_this3.baseURL);
            detailsLink.setParameter('mvcRenderCommandName', '/change_lists_history/view_details');
            detailsLink.setParameter('ctProcessId', processEntry.ctprocessId);
            var viewLink = Liferay.PortletURL.createURL(_this3.baseURL);
            detailsLink.setParameter('backURL', viewLink.toString());

            _this3.processEntries.push({
              description: processEntry.ctcollection.description,
              detailsLink: detailsLink.toString(),
              name: processEntry.ctcollection.name,
              percentage: processEntry.percentage,
              state: ChangeListsHistory._getState(processEntry.status),
              timestamp: new Intl.DateTimeFormat(Liferay.ThemeDisplay.getBCP47LanguageId(), {
                day: 'numeric',
                hour: 'numeric',
                minute: 'numeric',
                month: 'numeric',
                year: 'numeric'
              }).format(new Date(processEntry.date)),
              userInitials: processEntry.userInitials,
              userName: processEntry.userName
            });
          });
          Liferay.component('changeListHistoryManagementToolbar').totalItems = _this3.processEntries.length;
        });
        this.loaded = true;
      }
    }], [{
      key: "_getState",
      value: function _getState(processEntryStatus) {
        var statusText = processEntryStatus;

        if (processEntryStatus === 'successful') {
          statusText = 'published';
        }

        return statusText;
      }
    }]);

    return ChangeListsHistory;
  }(_PortletBase2.default);
  /**
   * State definition.
   *
   * @ignore
   * @static
   * @type {!Object}
   */

  exports.ChangeListsHistory = ChangeListsHistory;
  ChangeListsHistory.STATE = {
    baseURL: _metalState.Config.string(),
    filterStatus: _metalState.Config.string(),
    filterUser: _metalState.Config.string(),
    keywords: _metalState.Config.string(),
    orderByCol: _metalState.Config.string(),
    orderByType: _metalState.Config.string(),
    urlProcesses: _metalState.Config.string(),
    urlProcessUsers: _metalState.Config.string(),
    processEntries: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
      description: _metalState.Config.string(),
      detailsLink: _metalState.Config.string(),
      name: _metalState.Config.string(),
      percentage: _metalState.Config.number(),
      state: _metalState.Config.string(),
      timestamp: _metalState.Config.string(),
      userInitials: _metalState.Config.string(),
      userName: _metalState.Config.string()
    })),
    loaded: _metalState.Config.bool().value(false),

    /**
     * Path to images.
     *
     * @instance
     * @memberOf ChangeListsHistory
     * @review
     * @type {String}
     */
    spritemap: _metalState.Config.string().required()
  }; // Register component

  _metalSoy.default.register(ChangeListsHistory, _ChangeListsHistory.default);

  var _default = ChangeListsHistory;
  exports.default = _default;
  //# sourceMappingURL=ChangeListsHistory.es.js.map
});
//# sourceMappingURL=ChangeListsHistory.es.js.map